;;; "sql-null-support.scm" -- SQL NULL object and the ternary logic  -*- Scheme -*-

;;; Ivan Shmakov, 2007  This code is in public domain.

(cond-expand
  (chicken
    (eval-when (compile)
      (declare
        (fixnum)
        (inline)
        (no-procedure-checks)
        (no-bound-checks)
        (export
          sql-null
          sql-null?
          sql-not ) ) ) ) )

;;; Code:

(define sql-null void)

(define (sql-null? o)
  (eq? (sql-null) o) )

(define (sql-not o)
  (if (sql-null? o)
      o
      (not o) ) )

;;; sql-null-support.scm ends here
